
	ORG 28000

	jr StartCode
Color:		DEFB 2
ColorText:	DEFB 5
Level		DEFB 1
Length:		DEFB 24
Height:		DEFB 11
ColorTopEdge:	DEFB 0
SQCenter:	DEFW 22864
SQTopLeft:	DEFW 0
TextOutStart	DEFW 0
CText1:		DEFM "  BLUE  "
		DEFM "   RED  "
		DEFM " MAGENTA"
		DEFM "  GREEN "
		DEFM "  CYAN  "
		DEFM " YELLOW "
TextRoutineTabl:
;First 2 bytes is the start address of the character printing routine
;Third byte is the character width of each printed character
;Fourth byte is spare
		DEFW Printchar_normal,1
		DEFW Printchar_bold1,1
		DEFW Printchar_bold1,1
		DEFW Printchar_boldhigh,1
		DEFW Printchar_boldhigh,1
		DEFW Printchar_huge,2
		DEFW Printchar_huge,2
		DEFW Printchar_huge,2
		

StartCode:
	call DrawBox
	call WriteColor
	ret

WriteColor:
	ld a,(Level)
	dec a		;adjust for zero offset
	add a,a		;double A
	add a,a		;A * 4
	ld l,a
	ld h,0
	ld de,TextRoutineTabl
	add hl,de	;Print style routine table base
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	pop ix		;Save in IX for later
	ld hl,ModPrnt+1 ;Position in code to modify the called routine
	ld (hl),e
	inc hl
	ld (hl),d	;Modify the routine to call

;Calculate the start position of the text
	ld hl,(SQCenter)
	call AttrtoScr		;Get display address
	ld a,(ix+0)
walkbk:	dec hl   		;back 3 places for single width chars, 6 spaces for double width chars
	dec hl
	dec hl
	dec a
	jr nz,walkbk
	ld a,(ix+0)
	cp 2
	jr c, notbk
	dec hl
	dec hl
notbk:	ld (TextOutStart),hl


	ld a,(ColorText)
	dec a			;adjust for zero offset
	add a,a
	add a,a
	add a,a
	ld e,a
	ld d,0
	ld hl,CText1
	add hl,de
	ld b,8	;each string is 8 characters long
WCLoop1:
	push hl
	push bc
	ld l,(hl)
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,(23606)
	add hl,de
	ex de,hl
	ld hl,(TextOutStart)
ModPrnt:
	call Printchar_normal
	ld hl,(TextOutStart)
	ld c,(ix+0)
	ld b,0
	add hl,bc
	ld (TextOutStart),hl
	pop bc
	pop hl
	inc hl
	djnz WCLoop1
	ret

Printchar_normal:
	ld b,8
pchl1:
	ld a,(de)
	ld (hl),a
	inc de
	inc h
	djnz pchl1
	ret

Printchar_bold1:
	ld b,8
pchl2:
	ld a,(de)
	ld (hl),a
	rrca
	or (hl)
	ld (hl),a
	inc de
	inc h
	djnz pchl2
	ret

Printchar_boldhigh:
	push hl
	ld b,4
pchl3:
	ld a,(de)
	ld (hl),a
	rrca
	or (hl)
	ld (hl),a
	inc h
	ld (hl),a
	inc de
	inc h
	djnz pchl3
	pop hl
	ld bc,32
	add hl,bc
;2nd half of character
	ld b,4
pchl4:
	ld a,(de)
	ld (hl),a
	rrca
	or (hl)
	ld (hl),a
	inc h
	ld (hl),a
	inc de
	inc h
	djnz pchl4

	ret

Printchar_huge:
	ld c,2
pchl5:	push bc
	push hl
	ld b,4
pchl6:	push bc
	ld bc,0
	ld a,(de)
	push hl
	ld l,8
pchl7:	rlca
	jr c, BlkPix1
	and a
	rl c
	rl b
	rl c
	rl b
	jr phj1
BlkPix1:
	scf
	rl c
	rl b
	scf
	rl c
	rl b
phj1:	dec l
	jr nz, pchl7
	pop hl
	ld (hl),b
	inc hl
	ld (hl),c
	inc h
	ld (hl),c
	dec hl
	ld (hl),b
	pop bc
	inc de
	inc h
	djnz pchl6
	pop hl
	ld bc,32
	add hl,bc
	pop bc
	dec c
	jr nz, pchl5
	ret


DrawBox:ld a,(Height)
	and a
	rr a	;divide height by 2
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl	;Height / 2 * 32
	ex de,hl
	ld hl,(SQCenter)
	and a
	sbc hl,de	;HL = top line to start drawing
	ld a,(Length)
	and a
	rr a		;Length / 2
	ld e,a
	ld d,0
	and a
	sbc hl,de
	ld (SQTopLeft),hl
	ld a,(Color)
	ld c,a		;save a
	and 7
	or 56		;INK Colour, PAPER 7
	ld (ColorTopEdge),a
	ld a,c		;restore a
	cp 3
	jr nc, BlkInk
	or 192		;Make it ink 6 after rotate
BlkInk:	rlca
	rlca
	rlca
	ld c,a
	ld a,(Height)
	ld b,a
	and 1
	jr z,Jmp1	;Jump if the height is even
	ld a,(ColorTopEdge)
;Draw the first row with a different attribute
	push bc
	push hl
	push hl
	pop de
	inc e
	ld (hl),a
	ld a,(Length)
	dec a		;make it 1 less to get exact length using LDIR
	ld c,a
	ld b,0
	ldir
	pop hl
	call DrawHorizInk
	ld bc,32
	add hl,bc
	pop bc
Jmp1:	dec b
	jr z,End_1
Loop1:	ld a,c
	push bc
	push hl
	push hl
	pop de
	inc e
	ld (hl),c
	ld a,(Length)
	dec a
	ld c,a
	ld b,0
	ldir
	pop hl
	ld bc,32
	add hl,bc
	pop bc
	djnz Loop1
End_1:	ret

DrawHorizInk:
	push hl		;Save hl
	call AttrtoScr	;Get Display address in to HL
	inc h
	inc h
	inc h
	inc h
	ld b,4
Loop2:	push bc
	push hl
	push hl
	pop de
	inc e
	ld a,(Length)
	dec a
	ld c,a
	ld b,0
	ld (hl),255
	ldir
	pop hl
	pop bc
	inc h
	djnz Loop2
	pop hl		;Restore hl
	ret
AttrtoScr:
	ld a,h
	and 3
	rlca
	rlca
	rlca
	or 40h
	ld h,a
	ret

	END 28000
